package com.froglogic.examples;

import org.testng.ITestContext;
import org.testng.ITestListener;
import org.testng.ITestResult;

import java.net.HttpURLConnection;
import java.net.URL;

public class CocoReporter implements ITestListener {

    private final String USER_AGENT = "Mozilla/5.0";
    private final String urlBaseStr = "http://localhost:49221/Frogs/Coco/";

    public void sendGet(String urlStr){
        URL url;
        try {
            url = new URL(urlStr);
            HttpURLConnection con = (HttpURLConnection) url.openConnection();
            con.setRequestMethod("GET");
            con.setRequestProperty("User-Agent", USER_AGENT);
            int responseCode = con.getResponseCode();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    @Override
    public void onTestStart(ITestResult iTestResult) {
        String tcName = iTestResult.getName();
        String urlStr = urlBaseStr+tcName+"?start=1";
        sendGet(urlStr);
    }

    @Override
    public void onTestSuccess(ITestResult iTestResult) {
        String tcName = iTestResult.getName();
        String urlStr = urlBaseStr+tcName+"?testState=PASSED";
        sendGet(urlStr);
    }

    @Override
    public void onTestFailure(ITestResult iTestResult) {
        String tcName = iTestResult.getName();
        String urlStr = urlBaseStr+tcName+"?testState=FAILED";
        sendGet(urlStr);
    }

    @Override
    public void onTestSkipped(ITestResult iTestResult) {
    }

    @Override
    public void onTestFailedButWithinSuccessPercentage(ITestResult iTestResult) {
        String tcName = iTestResult.getName();
        String urlStr = urlBaseStr+tcName+"?testState=FAILED";
        sendGet(urlStr);
    }

    @Override
    public void onStart(ITestContext iTestContext) {
    }

    @Override
    public void onFinish(ITestContext iTestContext) {
    }
}
