package com.froglogic.examples;

import org.openqa.selenium.By;
import org.openqa.selenium.WebDriver;
import org.openqa.selenium.firefox.FirefoxDriver;
import org.openqa.selenium.support.ui.Select;
import org.testng.Assert;
import org.testng.annotations.*;

import java.util.concurrent.TimeUnit;

@Listeners({com.froglogic.examples.CocoReporter.class})
public class FrogShopBasicTests {

    private WebDriver driver;
    private String baseUrl = "http://localhost:49221/";
    private boolean acceptNextAlert = true;
    private StringBuffer verificationErrors = new StringBuffer();

    @BeforeTest
    public void setUp() throws Exception {
        driver = new FirefoxDriver();
        driver.manage().timeouts().implicitlyWait(30, TimeUnit.SECONDS);
        driver.get(baseUrl);
    }

    @Test
    public void testAddDeleteFrog(){
        driver.get(baseUrl + "/Frogs");
        driver.findElement(By.linkText("Create New")).click();
        driver.findElement(By.id("Spiecies")).clear();
        driver.findElement(By.id("Spiecies")).sendKeys("Darwin");
        driver.findElement(By.id("BirthDate")).clear();
        driver.findElement(By.id("BirthDate")).sendKeys("2014-12-03");
        driver.findElement(By.id("Gender")).clear();
        driver.findElement(By.id("Gender")).sendKeys("Male");
        driver.findElement(By.id("Price")).clear();
        driver.findElement(By.id("Price")).sendKeys("15");
        driver.findElement(By.cssSelector("input.btn.btn-default")).click();
        driver.findElement(By.linkText("Create New")).click();
        driver.findElement(By.id("Spiecies")).clear();
        driver.findElement(By.id("Spiecies")).sendKeys("Tree");
        driver.findElement(By.id("BirthDate")).clear();
        driver.findElement(By.id("BirthDate")).sendKeys("2014-12-02");
        driver.findElement(By.id("Gender")).clear();
        driver.findElement(By.id("Gender")).sendKeys("Female");
        driver.findElement(By.id("Price")).clear();
        driver.findElement(By.id("Price")).sendKeys("18");
        driver.findElement(By.cssSelector("input.btn.btn-default")).click();
        new Select(driver.findElement(By.id("frogGender"))).selectByVisibleText("Female");
        driver.findElement(By.cssSelector("input[type=\"submit\"]")).click();
        new Select(driver.findElement(By.id("frogGender"))).selectByVisibleText("All");
        driver.findElement(By.cssSelector("input[type=\"submit\"]")).click();
        driver.findElement(By.linkText("Delete")).click();
        driver.findElement(By.cssSelector("input.btn.btn-default")).click();
        driver.findElement(By.linkText("Delete")).click();
        driver.findElement(By.cssSelector("input.btn.btn-default")).click();
    }

    @Test()
    public void testFilterandView(){
        driver.get(baseUrl + "/Frogs");
        driver.findElement(By.linkText("Create New")).click();
        driver.findElement(By.id("Spiecies")).clear();
        driver.findElement(By.id("Spiecies")).sendKeys("Darwin");
        driver.findElement(By.id("BirthDate")).clear();
        driver.findElement(By.id("BirthDate")).sendKeys("2014-12-03");
        driver.findElement(By.id("Gender")).clear();
        driver.findElement(By.id("Gender")).sendKeys("Male");
        driver.findElement(By.id("Price")).clear();
        driver.findElement(By.id("Price")).sendKeys("15");
        driver.findElement(By.cssSelector("input.btn.btn-default")).click();
        driver.findElement(By.linkText("Create New")).click();
        driver.findElement(By.id("Spiecies")).clear();
        driver.findElement(By.id("Spiecies")).sendKeys("Tree");
        driver.findElement(By.id("BirthDate")).clear();
        driver.findElement(By.id("BirthDate")).sendKeys("2014-12-02");
        driver.findElement(By.id("Gender")).clear();
        driver.findElement(By.id("Gender")).sendKeys("Female");
        driver.findElement(By.id("Price")).clear();
        driver.findElement(By.id("Price")).sendKeys("18");
        driver.findElement(By.cssSelector("input.btn.btn-default")).click();
        new Select(driver.findElement(By.id("frogGender"))).selectByVisibleText("Female");
        driver.findElement(By.cssSelector("input[type=\"submit\"]")).click();
        driver.findElement(By.linkText("Details")).click();
        driver.findElement(By.linkText("Back to List")).click();
        new Select(driver.findElement(By.id("frogGender"))).selectByVisibleText("All");
        driver.findElement(By.cssSelector("input[type=\"submit\"]")).click();
        driver.findElement(By.linkText("Delete")).click();
        driver.findElement(By.cssSelector("input.btn.btn-default")).click();
        driver.findElement(By.linkText("Delete")).click();
        driver.findElement(By.cssSelector("input.btn.btn-default")).click();
        Assert.assertEquals("tomasz","tomasz");
    }

    @AfterTest
    public void endSession(){
        driver.quit();
    }

}
